This library provides convenient access to the LMNT REST API from server-side TypeScript or JavaScript.
For per-method API documentation with code examples, see the API Reference. This page covers TypeScript-specific SDK features and configuration.
Installation
npm install lmnt-nodeRequirements
TypeScript >= 4.5 is supported.
The following runtimes are supported:
- Node.js 20 LTS or later (non-EOL) versions.
- Deno v1.28.0 or higher.
- Bun 1.0 or later.
- Cloudflare Workers.
- Vercel Edge Runtime.
- Jest 28 or greater with the
"node"environment ("jsdom"is not supported at this time). - Nitro v2.6 or greater.
- Web browsers (up-to-date Chrome, Firefox, Safari, Edge, and more).
Note that React Native is not supported at this time. If you are interested in other runtimes, please open an issue.
Usage
import Lmnt from 'lmnt-node';
const client = new Lmnt({
apiKey: process.env['LMNT_API_KEY'], // This is the default and can be omitted
});
const response = await client.speech.generate({
text: 'hello world.',
voice: 'leah',
});
const content = await response.blob();
console.log(content);Request and response types
This library includes TypeScript definitions for all request params and response fields. You may import and use them like so:
import Lmnt from 'lmnt-node';
const client = new Lmnt({
apiKey: process.env['LMNT_API_KEY'], // This is the default and can be omitted
});
const params: Lmnt.SpeechGenerateParams = { text: 'hello world.', voice: 'leah' };
const response: Response = await client.speech.generate(params);Documentation for each method, request param, and response field is available in docstrings and will appear on hover in most modern editors.
File uploads
Request parameters that correspond to file uploads can be passed in many different forms:
File(or an object with the same structure)- a
fetchResponse(or an object with the same structure) - an
fs.ReadStream - the return value of the
toFilehelper
import fs from 'fs';
import Lmnt, { toFile } from 'lmnt-node';
const client = new Lmnt();
// If you have access to Node `fs` we recommend using `fs.createReadStream()`:
await client.voices.create({ name: 'new-voice', files: [fs.createReadStream('/path/to/file')] });
// Or if you have the web `File` API you can pass a `File` instance:
await client.voices.create({ name: 'new-voice', files: [new File(['my bytes'], 'file')] });
// You can also pass a `fetch` `Response`:
await client.voices.create({ name: 'new-voice', files: [await fetch('https://somesite/file')] });
// Or use the `toFile` helper for `Buffer` / `Uint8Array`:
await client.voices.create({ name: 'new-voice', files: [await toFile(Buffer.from('my bytes'), 'file')] });
await client.voices.create({ name: 'new-voice', files: [await toFile(new Uint8Array([0, 1, 2]), 'file')] });Handling errors
When the library is unable to connect to the API, or if the API returns a non-success status code (4xx or 5xx), a subclass of APIError is thrown:
const response = await client.speech.generate({ text: 'hello world.', voice: 'leah' }).catch(async (err) => {
if (err instanceof Lmnt.APIError) {
console.log(err.status); // 400
console.log(err.name); // BadRequestError
console.log(err.headers); // {server: 'nginx', ...}
} else {
throw err;
}
});Error codes are as follows:
| Status Code | Error Type |
|---|---|
| 400 | BadRequestError |
| 401 | AuthenticationError |
| 403 | PermissionDeniedError |
| 404 | NotFoundError |
| 422 | UnprocessableEntityError |
| 429 | RateLimitError |
| >=500 | InternalServerError |
| N/A | APIConnectionError |
Retries
Certain errors are automatically retried twice by default, with a short exponential backoff. Connection errors, 408 Request Timeout, 409 Conflict, 429 Rate Limit, and >=500 Internal errors are all retried by default.
Use the maxRetries option to configure or disable this:
// Configure the default for all requests:
const client = new Lmnt({
maxRetries: 0, // default is 2
});
// Or, configure per-request:
await client.speech.generate(
{ text: 'hello world.', voice: 'leah' },
{ maxRetries: 5 },
);Timeouts
Requests time out after 1 minute by default. Configure this with the timeout option:
// Configure the default for all requests:
const client = new Lmnt({
timeout: 20 * 1000, // 20 seconds (default is 1 minute)
});
// Override per-request:
await client.speech.generate(
{ text: 'hello world.', voice: 'leah' },
{ timeout: 5 * 1000 },
);On timeout, an APIConnectionTimeoutError is thrown. Requests that time out are retried twice by default.
Advanced usage
Accessing raw Response data (e.g., headers)
The "raw" Response returned by fetch() can be accessed through the .asResponse() method on the APIPromise that all methods return. .asResponse() returns as soon as the headers for a successful response are received and does not consume the body, so you are free to write custom parsing or streaming logic.
You can also use .withResponse() to get the raw Response along with the parsed data:
const client = new Lmnt();
const response = await client.speech
.generate({ text: 'hello world.', voice: 'leah' })
.asResponse();
console.log(response.headers.get('X-My-Header'));
console.log(response.statusText);
const { data, response: raw } = await client.speech
.generate({ text: 'hello world.', voice: 'leah' })
.withResponse();
console.log(raw.headers.get('X-My-Header'));
console.log(data);Making custom/undocumented requests
This library is typed for convenient access to the documented API. If you need to access undocumented endpoints, params, or response properties, the library can still be used.
Undocumented endpoints
To make requests to undocumented endpoints, you can use client.get, client.post, and other HTTP verbs. Options on the client, such as retries, will be respected when making these requests.
await client.post('/some/path', {
body: { some_prop: 'foo' },
query: { some_query_arg: 'bar' },
});Undocumented request params
To make requests using undocumented parameters, use // @ts-expect-error on the undocumented parameter. The library doesn't validate at runtime that the request matches the type, so any extra values you send will be sent as-is.
client.foo.create({
foo: 'my_param',
bar: 12,
// @ts-expect-error baz is not yet public
baz: 'undocumented option',
});For requests with the GET verb, any extra params will be in the query; all other requests will send the extra param in the body.
If you want to explicitly send an extra argument, you can do so with the query, body, and headers request options.
Undocumented response properties
To access undocumented response properties, you may access the response object with // @ts-expect-error on the response object, or cast the response object to the requisite type. The SDK does not validate or strip extra properties from the response.
Customizing the fetch client
By default, this library uses node-fetch in Node, and expects a global fetch function in other environments.
If you would prefer to use a global, web-standards-compliant fetch function even in a Node environment (for example, when running Node with --experimental-fetch or using Next.js, which polyfills with undici), add the following import before your first import from lmnt-node:
import 'lmnt-node/shims/web';
import Lmnt from 'lmnt-node';To do the inverse, add import 'lmnt-node/shims/node'.
You can also provide a custom fetch function when instantiating the client, useful for inspecting or altering the Request or Response before/after each request:
import { fetch } from 'undici';
import Lmnt from 'lmnt-node';
const client = new Lmnt({
fetch: async (url, init) => {
console.log('About to make a request', url, init);
const response = await fetch(url, init);
console.log('Got response', response);
return response;
},
});If given a DEBUG=true environment variable, this library logs all requests and responses automatically. This is intended for debugging only and may change in the future without notice.
Configuring an HTTP(S) Agent (e.g., for proxies)
By default, this library uses a stable agent for all http/https requests to reuse TCP connections, eliminating many TCP & TLS handshakes and shaving around 100ms off most requests.
To disable or customize this behavior — for example, to route requests through a proxy — pass an httpAgent:
import http from 'http';
import { HttpsProxyAgent } from 'https-proxy-agent';
// Configure the default for all requests:
const client = new Lmnt({
httpAgent: new HttpsProxyAgent(process.env.PROXY_URL),
});
// Override per-request:
await client.speech.generate(
{ text: 'hello world.', voice: 'leah' },
{ httpAgent: new http.Agent({ keepAlive: false }) },
);Semantic versioning
This package generally follows SemVer, though certain backwards-incompatible changes may be released as minor versions:
- Changes that only affect static types, without breaking runtime behavior.
- Changes to library internals which are technically public but not intended or documented for external use.
- Changes that we don't expect to impact the vast majority of users in practice.